<?php
/**
* @version 1.0.0
* @package RSSearch! 1.0.0
* @copyright (C) 2011 www.rsjoomla.com
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.plugin.plugin');
 
class plgRSSearchRSEvents extends JPlugin
{
	public function __construct( &$subject, $config ) {
		parent::__construct( $subject, $config );
	}
	
	public function getResults(&$results, $search, $params) {
	    $db			= JFactory::getDBO();
	    $fields		= (array) $this->params->get('searchfields','');
	    $orderby 	= $this->params->get('orderby','Eventname');
	    $categories = (array) $this->params->get('rsecategories','');
	    $asc_desc 	= $this->params->get('asc_desc','ASC');
	    $itemId 	= $this->params->get('Itemid','');
	    $itemId 	= (empty($itemId) ? '' : '&Itemid='.$itemId);

		JFactory::getLanguage()->load('plg_rssearch_rsevents',JPATH_ADMINISTRATOR);

		require_once JPATH_ADMINISTRATOR . '/components/com_search/helpers/search.php';

		foreach($fields as $field) {
			if ($field == 'rsevents_events') {
				$tablecolumns 	= array('EventName','EventHost','EventStartDate','EventEndDate');
				$where_catid 	= '';
				
				if (in_array('rsevents_categories', $fields)) {					
					if(!in_array('', $categories)){
						JArrayHelper::toInteger($categories);
						$where_catid = ' AND '.$db->qn('c.IdCategory').' IN ('.implode(',', $categories).') ';
					}
				}

				$query = 'SELECT '.$db->qn('c.IdCategory').', '.$db->qn('e.IdEvent').', '.$db->qn('e.EventName').', '.$db->qn('e.EventDescription').', '.$db->qn('e.EventAlias').' FROM '.$db->qn('#__rsevents_events','e').' LEFT JOIN '.$db->qn('#__rsevents_events_cat','c').' ON '.$db->qn('e.IdEvent').' = '.$db->qn('c.IdEvent').' WHERE ('.$db->qn('e.EventName').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('e.EventDescription').' LIKE '.$db->q('%'.$search.'%').') AND '.$db->qn('e.published').' = 1 '.$where_catid.' GROUP BY '.$db->qn('e.IdEvent');
				
				if (in_array($orderby,$tablecolumns))
					$query .=' ORDER BY '.$db->qn('e.'.$orderby).' '.$db->escape($asc_desc);

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('EventName', 'EventDescription')) ) continue;

						$tmp 		= new stdClass();
						$tmp->title = $item->EventName;
						$tmp->link 	= JRoute::_('index.php?option=com_rsevents&view=events&layout=show&cid='.$item->IdEvent.':'.$item->EventAlias.$itemId);
						$tmp->text 	= $item->EventDescription;
						$tmp->type 	= JText::_('RSF_RSE_XML_EVENT');
						$results[] 	= $tmp;
					}
				}
			} elseif($field == 'rsevents_categories') {
				$where_catid = '';
				
				if(!in_array('', $categories)){
					JArrayHelper::toInteger($categories);
					$where_catid = ' AND '.$db->qn('IdCategory').' IN ('.implode(',', $categories).') ';
				}

				$query = 'SELECT '.$db->qn('IdCategory').', '.$db->qn('CategoryName').', '.$db->qn('CategoryDescription').', '.$db->qn('CategoryAlias').' FROM '.$db->qn('#__rsevents_categories').' WHERE ('.$db->qn('CategoryName').' LIKE '.$db->q('%'.$search.'%').' OR '.$db->qn('CategoryDescription').' LIKE '.$db->q('%'.$search.'%').') AND '.$db->qn('published').' = 1 '.$where_catid.' GROUP BY '.$db->qn('IdCategory').', '.$db->qn('CategoryName').', '.$db->qn('CategoryDescription').' ORDER BY '.$db->qn('ordering');

				$db->setQuery($query);
				if ($list = $db->loadObjectList()) {
					foreach ($list as $item) {
						if ( !searchHelper::checkNoHTML($item, $search, array('CategoryName', 'CategoryDescription')) ) continue;

						$tmp 		= new stdClass();
						$tmp->title = $item->CategoryName;
						$tmp->link 	= JRoute::_('index.php?option=com_rsevents&view=events&layout=listcategoryevents&cid='.$item->IdCategory.':'.$item->CategoryAlias.$itemId);
						$tmp->text 	= $item->CategoryDescription;
						$tmp->type 	= JText::_('RSF_RSE_XML_CATEGORY');
						$results[] 	= $tmp;
					}
				}
			}
		}
	    return true;
	}
}